// SPDX-License-Identifier: MIT
pragma solidity ^0.8.20;

import {Script,console} from "forge-std/Script.sol";
import "../src/UniswapV2Factory.sol";

import "./AddressFileRW.sol";

contract UniswapV2FactoryScript is Script {
    function setUp() public {}

    function run() public {
        uint256 privateKey = vm.envUint("DEPLOYMENT_PRIVATE_KEY");
        address feeToAddress = vm.envAddress("FEE_TO_ADDRESS");
        address account = vm.addr(privateKey);

        console.log("Deployment Account : ", account);
        console.log("Fee to Address : ", feeToAddress);

        vm.broadcast(privateKey);
        UniswapV2Factory factory = new UniswapV2Factory(feeToAddress);
        console.log("\n\tFactory Address: ", address(factory));
    }
}
